> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Set field definitions on the schema

POST https://{tenant_name}.benchling.com/api/v3/entry-schema/{entry_schema_id}:set-field-definitions
Content-Type: application/json

Set field definitions on the schema

Reference: https://docs.benchling.com/docs/api/benchling-api/entry-schema/setfielddefinitions

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `entry_schema_id` (string, required) — ID of the EntrySchema.

### Headers

- `EARLY-ACCESS` (string, optional) — Set to true to access beta operations via /api/v3.

### Body (application/json)

This endpoint expects an object.

- `fieldDefinitions` (list of EntrySchemaSetFieldDefinitionsInputFieldDefinitionsItem, required)

## Response

### 202

Task started

- `pollingUri` (string, optional)
- `taskId` (string, optional)

## Errors

### 400 Entry Schema Set Field Definitions Request Bad Request Error

Bad Request

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 403 Entry Schema Set Field Definitions Request Forbidden Error

Forbidden

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 404 Entry Schema Set Field Definitions Request Not Found Error

Not Found

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 409 Entry Schema Set Field Definitions Request Conflict Error

Conflict

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 429 Entry Schema Set Field Definitions Request Too Many Requests Error

Too Many Requests

- `detail` (TooManyRequestsErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)
- `violated-policies` (list of enum, optional) — The budget policies that rejected the request, in canonical order: `user`, `integration`, then `tenant`.
  - Allowed values: `user`, `integration`, `tenant`

### 500 Entry Schema Set Field Definitions Request Internal Server Error

Internal Server Error

- `detail` (InternalServerErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `errorId` (string, optional)

## Types

### EntrySchemaSetFieldDefinitionsInputFieldDefinitionsItem

### GeneralErrorDetail

### TooManyRequestsErrorBodyDetail

### InternalServerErrorBodyDetail

### CreateBooleanFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `BOOLEAN`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateDateFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DATE`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateDateTimeFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DATE_TIME`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateDecimalFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DECIMAL`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `displayPrecision` (integer, optional) — The number of decimal places to display (0 to 10).
- `numericMax` (double, optional) — The maximum allowed value, inclusive.
- `numericMin` (double, optional) — The minimum allowed value, inclusive.
- `unitId` (string, optional) — The API ID of the unit to associate with this field.

### CreateIntegerFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `INTEGER`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `numericMax` (double, optional) — The maximum allowed value, inclusive.
- `numericMin` (double, optional) — The minimum allowed value, inclusive.
- `unitId` (string, optional) — The API ID of the unit to associate with this field.

### CreateLongTextFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `LONG_TEXT`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateTextFieldDefinitionInput

- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `TEXT`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateAaSequenceLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any AA sequence.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `AA_SEQUENCE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateProteinLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any antibody.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `PROTEIN_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateRequestLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay request.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `REQUEST_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateResultLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay result.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RESULT_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateRunLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay run.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RUN_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateAttachmentLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ATTACHMENT_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateCustomEntityLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any custom entity.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `CUSTOM_ENTITY_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateDnaOligoLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DNA_OLIGO_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateDnaSequenceLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any DNA sequence.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DNA_SEQUENCE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateDropdownLinkFieldDefinitionInput

- `dropdownId` (string, required) — The API ID of the Dropdown that defines the available options.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DROPDOWN`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateAnyEntityLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ENTITY_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateEntryLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ENTRY_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateEquipmentLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any equipment.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `EQUIPMENT_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateFieldsetLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `FIELDSET_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateMixtureLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any mixture.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `MIXTURE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateMoleculeLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any molecule.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `MOLECULE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateOligoConjugateLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any oligo conjugate.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `OLIGO_CONJUGATE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateOligoDuplexLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any oligo duplex.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `OLIGO_DUPLEX_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateRnaSequenceLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RNA_SEQUENCE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateRnaOligoLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RNA_OLIGO_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### CreateStorableLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any storage location.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `STORAGE_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### CreateSystemCategoryLinkFieldDefinitionInput

- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `SYSTEM_CATEGORY_LINK`
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateBooleanFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `BOOLEAN`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateDateFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DATE`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateDateTimeFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DATE_TIME`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateDecimalFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DECIMAL`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `displayPrecision` (integer, optional) — The number of decimal places to display (0 to 10).
- `numericMax` (double, optional) — The maximum allowed value, inclusive.
- `numericMin` (double, optional) — The minimum allowed value, inclusive.
- `unitId` (string, optional) — The API ID of the unit to associate with this field.

### UpdateIntegerFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `INTEGER`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `numericMax` (double, optional) — The maximum allowed value, inclusive.
- `numericMin` (double, optional) — The minimum allowed value, inclusive.
- `unitId` (string, optional) — The API ID of the unit to associate with this field.

### UpdateLongTextFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `LONG_TEXT`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateTextFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `TEXT`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateAaSequenceLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any AA sequence.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `AA_SEQUENCE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateProteinLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any antibody.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `PROTEIN_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateRequestLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay request.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `REQUEST_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateResultLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay result.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RESULT_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateRunLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any assay run.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RUN_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateAttachmentLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ATTACHMENT_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateCustomEntityLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any custom entity.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `CUSTOM_ENTITY_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateDnaOligoLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DNA_OLIGO_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateDnaSequenceLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any DNA sequence.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DNA_SEQUENCE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateDropdownLinkFieldDefinitionInput

- `dropdownId` (string, required) — The API ID of the Dropdown that defines the available options.
- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `DROPDOWN`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateAnyEntityLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ENTITY_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateEntryLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `ENTRY_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateEquipmentLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any equipment.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `EQUIPMENT_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateFieldsetLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `FIELDSET_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateMixtureLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any mixture.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `MIXTURE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateMoleculeLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any molecule.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `MOLECULE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateOligoConjugateLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any oligo conjugate.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `OLIGO_CONJUGATE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateOligoDuplexLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any oligo duplex.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `OLIGO_DUPLEX_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateRnaSequenceLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RNA_SEQUENCE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateRnaOligoLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `RNA_OLIGO_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.
- `isParent` (boolean, optional) — When true, indicates a parent-child relationship used in the registry's lot-numbering functionality.

### UpdateStorableLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required, nullable) — The API ID of the schema to constrain links to, or null to allow links to any storage location.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `STORAGE_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

### UpdateSystemCategoryLinkFieldDefinitionInput

- `id` (string, required) — The API ID of the field definition to update.
- `isMulti` (boolean, required) — When true, multiple linked values are allowed.
- `isRequired` (boolean, required) — When true, a value must be provided for this field.
- `linkDefinitionId` (string, required) — The API ID of the schema/interface that linked items must belong to.
- `name` (string, required) — The user-facing display name of this field definition. Must be unique within the schema.
- `systemName` (string, required) — The machine-readable identifier used as the warehouse column name. Must be unique within the schema.
- `type` (enum, required)
  - Allowed values: `SYSTEM_CATEGORY_LINK`
- `archiveReason` (string, optional) — The reason this field definition was archived, if applicable.
- `archived` (boolean, optional) — Whether this field definition has been archived.
- `description` (string, optional) — An optional user-provided description of this field definition.

## Examples

**Request**

```json
{
  "fieldDefinitions": [
    {
      "isRequired": true,
      "name": "name",
      "systemName": "systemName",
      "type": "BOOLEAN"
    }
  ]
}
```

**Response**

```json
{
  "pollingUri": "pollingUri",
  "taskId": "taskId"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v3/entry-schema/entry_schema_id:set-field-definitions"

payload = { "fieldDefinitions": [
        {
            "isRequired": True,
            "name": "name",
            "systemName": "systemName",
            "type": "BOOLEAN"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v3/entry-schema/entry_schema_id:set-field-definitions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"fieldDefinitions":[{"isRequired":true,"name":"name","systemName":"systemName","type":"BOOLEAN"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```